<template>
  <VAppBar
    :height="56"
    color="primary"
    dark
    clipped-left
    app
  >
    <VExpandXTransition group>
      <div
        v-if="!btnSearch"
        class="d-flex align-center"
      >
        <VAppBarNavIcon @click="drawer = !drawer" />
        <VToolbarTitle>Work&Learn</VToolbarTitle>
      </div>
    </VExpandXTransition>

    <VSpacer v-if="!btnSearch" />
    <VTextField
      v-show="btnSearch"
      v-model="search"
      label="Procurar"
      prepend-inner-icon="mdi-magnify"
      append-outer-icon="mdi-close"
      flat
      solo-inverted
      hide-details
      @focus="focusSearch = true"
      @blur="focusSearch = false"
      @click:append-outer="btnSearch = false"
    />

    <VExpandXTransition>
      <div
        v-if="!btnSearch"
        class="d-flex align-center fill-height"
      >
        <VBtn
          icon
          @click="btnSearch = !btnSearch"
        >
          <VIcon>mdi-magnify</VIcon>
        </VBtn>
        <VBtn icon>
          <VIcon>mdi-bell</VIcon>
        </VBtn>

        <VDivider
          class="mx-2"
          inset
          vertical
        />

        <VTooltip bottom>
          <template v-slot:activator="{ on }">
            <VBtn
              icon
              @click="toggleDark"
              v-on="on"
            >
              <VIcon>mdi-invert-colors</VIcon>
            </VBtn>
          </template>
          <span>Inverter a cor</span>
        </VTooltip>
        <VTooltip bottom>
          <template v-slot:activator="{ on }">
            <VBtn
              icon
              href="//gitlab.com/i.leonardo/ativ-ead-santodigital"
              target="_blank"
              v-on="on"
            >
              <img
                src="@/assets/github/logo-light.png"
                width="24px"
              >
            </VBtn>
          </template>
          <span>GitHub</span>
        </VTooltip>
      </div>
    </VExpandXTransition>
  </VAppBar>
</template>

<script lang="ts">
import {
  Component, Vue, Mutation, Watch,
} from 'nuxt-property-decorator';

@Component
export default class TheHeader extends Vue {
  @Mutation
  toggleDark!: void

  btnSearch = false

  focusSearch = false

  search = ''

  get drawer() {
    return this.$store.state.drawer;
  }

  set drawer(bool: boolean) {
    this.$store.commit('setDrawer', bool);
  }

  @Watch('btnSearch')
  clearText(bool: boolean) {
    if (!bool) this.search = '';
  }
}
</script>
